clear all
close all
% original polygon vertices
d = [-1,-0.5,0,0.6,1.4,0.7,-0.1,-0.8;...
0,0.3,0.5,0.4,0.1,-0.4,-0.5,-0.3];
k = 3; % Bspline degree
level = 1; % number of steps of polygon refinement
% end of user defined parameters
n = size(d,2);
M = 100;
t = linspace(k,n+k,M); 
s = zeros(2,M);
for j = 1:n+k-min(k-1,1)
  s = s+diag(d(:,mod(j-1,n)+1))*repmat(N(k,t-j),2,1);
end
vertices = d;
for l = 1:level
  m = size(vertices,2);
  vertices = reshape(repmat(vertices,2,1),2,2*m);
  for i = 1:k-1
    vertices = [vertices,vertices(:,1)];
    vertices = (vertices(:,1:end-1)+vertices(:,2:end))/2;
  end
end
plot(d(1,:),d(2,:),'o',vertices(1,:),vertices(2,:),'*',s(1,:),s(2,:),'.')
legend('original polygon',sprintf('refined polygon (n = %d)',level),...
sprintf('curve (k = %d)',k))
